import { FormAssociated } from "../form-associated/index";
export declare enum TextAreaAppearance {
    filled = "filled",
    outline = "outline"
}
export declare enum TextAreaResize {
    none = "none",
    both = "both",
    horizontal = "horizontal",
    vertical = "vertical"
}
export declare class TextArea extends FormAssociated<HTMLTextAreaElement> {
    appearance: TextAreaAppearance;
    readOnly: boolean;
    private readOnlyChanged;
    resize: TextAreaResize;
    textarea: HTMLTextAreaElement;
    autofocus: boolean;
    private autofocusChanged;
    cols: number;
    formId: string;
    list: string;
    private listChanged;
    maxlength: number;
    private maxlengthChanged;
    minlength: number;
    private minlengthChanged;
    name: string;
    placeholder: string;
    rows: number;
    spellcheck: boolean;
    private spellcheckChanged;
    defaultSlottedNodes: Node[];
    valueChanged(): void;
    protected proxy: HTMLTextAreaElement;
    connectedCallback(): void;
    handleTextInput: () => void;
}
