import { FormAssociated } from "../form-associated/index";
import { StartEnd } from "../patterns/start-end";
export declare enum TextFieldAppearance {
    filled = "filled",
    outline = "outline"
}
export declare enum TextFieldType {
    email = "email",
    password = "password",
    tel = "tel",
    text = "text",
    url = "url"
}
export declare class TextField extends FormAssociated<HTMLInputElement> {
    appearance: TextFieldAppearance;
    readOnly: boolean;
    private readOnlyChanged;
    autofocus: boolean;
    private autofocusChanged;
    placeholder: string;
    private placeholderChanged;
    type: TextFieldType;
    private typeChanged;
    list: string;
    private listChanged;
    maxlength: number;
    private maxlengthChanged;
    minlength: number;
    private minlengthChanged;
    pattern: string;
    private patternChanged;
    size: number;
    private sizeChanged;
    spellcheck: boolean;
    private spellcheckChanged;
    defaultSlottedNodes: Node[];
    private valueChanged;
    control: HTMLInputElement;
    protected proxy: HTMLInputElement;
    constructor();
    connectedCallback(): void;
    handleTextInput(): void;
}
export interface TextField extends StartEnd {
}
