import { __decorate } from "tslib";
import { attr, FASTElement, nullableNumberConverter, } from "@microsoft/fast-element";
import { StartEnd } from "../../patterns/start-end";
import { applyMixins } from "../../utilities/apply-mixins";
export class AccordionItem extends FASTElement {
    constructor() {
        super(...arguments);
        this.headinglevel = 2;
        this.expanded = false;
        /* eslint-disable-next-line @typescript-eslint/no-unused-vars */
        this.clickHandler = (e) => {
            this.expanded = !this.expanded;
            this.change();
        };
        this.change = () => {
            this.$emit("change");
        };
    }
}
__decorate([
    attr({
        attribute: "heading-level",
        mode: "fromView",
        converter: nullableNumberConverter,
    })
], AccordionItem.prototype, "headinglevel", void 0);
__decorate([
    attr({ mode: "boolean" })
], AccordionItem.prototype, "expanded", void 0);
__decorate([
    attr
], AccordionItem.prototype, "id", void 0);
applyMixins(AccordionItem, StartEnd);
