import { __decorate } from "tslib";
import { attr, nullableNumberConverter, observable } from "@microsoft/fast-element";
import { FormAssociated } from "../form-associated/index";
export var TextAreaAppearance;
(function (TextAreaAppearance) {
    TextAreaAppearance["filled"] = "filled";
    TextAreaAppearance["outline"] = "outline";
})(TextAreaAppearance || (TextAreaAppearance = {}));
export var TextAreaResize;
(function (TextAreaResize) {
    TextAreaResize["none"] = "none";
    TextAreaResize["both"] = "both";
    TextAreaResize["horizontal"] = "horizontal";
    TextAreaResize["vertical"] = "vertical";
})(TextAreaResize || (TextAreaResize = {}));
export class TextArea extends FormAssociated {
    constructor() {
        super(...arguments);
        this.appearance = TextAreaAppearance.outline;
        this.resize = TextAreaResize.none;
        this.cols = 20;
        this.proxy = document.createElement("textarea");
        this.handleTextInput = () => {
            this.$emit("change", this.textarea.value);
        };
    }
    readOnlyChanged() {
        if (this.proxy instanceof HTMLElement) {
            this.proxy.readOnly = this.readOnly;
        }
    }
    autofocusChanged() {
        if (this.proxy instanceof HTMLElement) {
            this.proxy.autofocus = this.autofocus;
        }
    }
    listChanged() {
        if (this.proxy instanceof HTMLElement) {
            this.proxy.setAttribute("list", this.list);
        }
    }
    maxlengthChanged() {
        if (this.proxy instanceof HTMLElement) {
            this.proxy.maxLength = this.maxlength;
        }
    }
    minlengthChanged() {
        if (this.proxy instanceof HTMLElement) {
            this.proxy.minLength = this.minlength;
        }
    }
    spellcheckChanged() {
        if (this.proxy instanceof HTMLElement) {
            this.proxy.spellcheck = this.spellcheck;
        }
    }
    valueChanged() {
        if (this.textarea && this.value !== this.textarea.value) {
            this.textarea.value = this.value;
        }
        if (this.proxy instanceof HTMLElement) {
            this.proxy.value = this.value;
        }
    }
    connectedCallback() {
        super.connectedCallback();
        if (this.value) {
            this.textarea.value = this.value;
            this.setFormValue(this.value, this.value);
        }
    }
}
__decorate([
    attr
], TextArea.prototype, "appearance", void 0);
__decorate([
    attr({ mode: "boolean" })
], TextArea.prototype, "readOnly", void 0);
__decorate([
    attr
], TextArea.prototype, "resize", void 0);
__decorate([
    attr({ mode: "boolean" })
], TextArea.prototype, "autofocus", void 0);
__decorate([
    attr({ converter: nullableNumberConverter, mode: "fromView" })
], TextArea.prototype, "cols", void 0);
__decorate([
    attr({ attribute: "form" })
], TextArea.prototype, "formId", void 0);
__decorate([
    attr
], TextArea.prototype, "list", void 0);
__decorate([
    attr({ converter: nullableNumberConverter })
], TextArea.prototype, "maxlength", void 0);
__decorate([
    attr({ converter: nullableNumberConverter })
], TextArea.prototype, "minlength", void 0);
__decorate([
    attr
], TextArea.prototype, "name", void 0);
__decorate([
    attr
], TextArea.prototype, "placeholder", void 0);
__decorate([
    attr({ converter: nullableNumberConverter, mode: "fromView" })
], TextArea.prototype, "rows", void 0);
__decorate([
    attr({ mode: "boolean" })
], TextArea.prototype, "spellcheck", void 0);
__decorate([
    observable
], TextArea.prototype, "defaultSlottedNodes", void 0);
